/*****************************/
/* Header File: ALERT.H      */
/* Companion file to ALERT.C */
/*****************************/

#ifndef TRUE
#define TRUE !0
#define FALSE 0
#endif

#define NAFORMERR -1
#define NAMEMERR -2

/* Shortened Version of Object Macros Originally Published with
   Atari's CPX code. I believe the credit goes to either to Mike
   Fulton or Ken B.*/

typedef struct sColorword
{
     unsigned cborder : 4;
     unsigned ctext   : 4;
     unsigned replace : 1;
     unsigned pattern : 3;
     unsigned cfill   : 4;

} Colorword;

typedef struct sObInfo
{
     char     letter;
     signed char border;
     Colorword   c;
} ObInfo;

#define ObFlags(obj)    ( tree[(obj)].ob_flags )
#define ObSpec(obj)     ( tree[(obj)].ob_spec )
#define ObState(obj)    ( tree[(obj)].ob_state )
#define ObX(obj)        ( tree[(obj)].ob_x )
#define ObY(obj)        ( tree[(obj)].ob_y )
#define ObW(obj)        ( tree[(obj)].ob_width )
#define ObH(obj)        ( tree[(obj)].ob_height )
#define ObRect(obj)     ( *(GRECT *)(&(tree[(obj)].ob_x)) )

#define HideObj(obj)            ( ObFlags(obj) |= HIDETREE )
#define ShowObj(obj)            ( ObFlags(obj) &= ~HIDETREE )
#define MakeDefault(obj)        ( ObFlags(obj) |= DEFAULT )
#define NoDefault(obj)          ( ObFlags(obj) &= ~DEFAULT )
#define Deselect(obj)           ( ObState(obj) &= ~SELECTED )
#define IsOutlined(obj)         ( ObState(obj) & OUTLINED )
#define IsShadowed(obj)         ( ObState(obj) & SHADOWED )

/* I added this one */
#define BiData(idx)             ( rs_bitblk[idx].bi_pdata )

/* Shorthand macro to pass parameters for objc_draw() */
#define PTRS(r) r->g_x, r->g_y, r->g_w, r->g_h
#define ELTS(r) r.g_x, r.g_y, r.g_w, r.g_h

/* Resource Defines */

#define   ALERTS         0

#define ICON             1    
#define LINE1            2
#define LINE2            3
#define LINE3            4
#define LINE4            5
#define LINE5            6
#define BUTTON1          7
#define BUTTON2          8
#define BUTTON3          9
